
  PROGRAM

  INCLUDE('ABBROWSE.INC'),ONCE
  INCLUDE('ABPOPUP.INC'),ONCE

  MAP
  END

MyPopupClass  CLASS(PopupClass) !note there is no virtual procedures in parent class, watch out not overriding procedures expected to be called internally in it
NewPopupProc    PROCEDURE
              END

MyBrowseClass CLASS(BrowseClass)
MyPopup         &MyPopupClass
Init              PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)   !,EXTENDS  !other init is not virtual, this also would need to be overriden
Init              PROCEDURE(IListControl IC,VIEW V,BrowseQueue LQ,RelationManager RM,WindowManager WM)         !,EXTENDS  !overriden to force calling AfterInit
AfterInit         PROCEDURE()                                                                                             !kill/destruct original popup after original init and create a new popup from derived
              END

MyBrowse      MyBrowseClass

  CODE

  MyBrowse.AfterInit() !Called explicitly for this example
  MyBrowse.Popup.AddItem('First item')
  MyBrowse.MyPopup.AddItem('Second item')
  MyBrowse.MyPopup.NewPopupProc()

MyPopupClass.NewPopupProc PROCEDURE
  CODE
  MESSAGE('Popup items:' & SELF.GetItems())

MyBrowseClass.Init  PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager F,WindowManager WM)
  CODE
  PARENT.Init(ListBox,Posit,V,Q,F,WM)
  SELF.AfterInit()

MyBrowseClass.Init  PROCEDURE(IListControl LI,VIEW V,BrowseQueue LQ,RelationManager F,WindowManager WM)
  CODE
  PARENT.Init(LI,V,LQ,F,WM)
  SELF.AfterInit()

MyBrowseClass.AfterInit  PROCEDURE()
  CODE
  IF ~SELF.Popup&=NULL
    SELF.Popup.Kill
    DISPOSE(SELF.Popup)
  END
  SELF.MyPopup &= NEW MyPopupClass
  SELF.Popup &= SELF.MyPopup
  ASSERT(~SELF.Popup&=NULL)
  SELF.Popup.Init
  